#include <msp430g2553.h>
#include "LCD12864.h"
#include "common.h"
#include "GPIO.h"
           //ʾС:numʾֵlenʾݳȡ
              /*LCD12864IOڳʼ*/
void LCD12864_IO_Init(){
	    GPIO_Quick_Init(2,1,0);
	    GPIO_Quick_Init(2,1,2);
}                        //IOڳʼ
void LCD12864_Serial_Init(){
    CS_High;
    DATA_High;
    CLOCK_High;

    Delay_us( 500 );
    LCD12864_Serial_WriteCom( 0x30 );
    Delay_us( 500 );
    LCD12864_Serial_WriteCom( 0x0C );
    Delay_us( 500 );
    LCD12864_Serial_WriteCom( 0x01 );
    Delay_us( 500 );
    //LCD12864_WriteCom( 0x06 );		 //
    //LCD12864_Delay( 100 );
}                     //гʼ
             /* LCD12864дݺ*/
void LCD12864_Serial_WriteByte( uint8 zdata ){
	    uint8 i;
	    for( i = 0; i < 8; i++ )
	    {
	        //CLOCK_Low;

	        if( (zdata << i) & 0x80 )
	        {
	           DATA_OUT;
	           DATA_High;
	        }

	        else
	        {
	           DATA_OUT;
	           DATA_Low;
	        }


	        CLOCK_Low;
	        Delay_us( 50 );
	        CLOCK_High;
	    }
}  //дֽں
void LCD12864_Serial_WriteCom( uint8 com ){
    CS_High;
    Delay_us( 50 );
    LCD12864_Serial_WriteByte( 0xf8 ); 		                //һֽ
    Delay_us( 50 );
    LCD12864_Serial_WriteByte( com & 0xf0 );     		//ڶֽ
    Delay_us( 50 );
    LCD12864_Serial_WriteByte( ( com << 4 ) & 0xf0 );	        //ֽ
    Delay_us( 50 );
    CS_Low;
    Delay_us( 50 );
}      //дָ
void LCD12864_Serial_WriteData( uint8 _data ){
	    CS_High;
	    Delay_us( 50 );
	    LCD12864_Serial_WriteByte( 0xfa );				    //һֽ
	    Delay_us( 50 );
	    LCD12864_Serial_WriteByte( _data & 0xf0 );  		    //ڶֽ
	    Delay_us( 50 );
	    LCD12864_Serial_WriteByte( ( _data << 4 ) & 0xf0 );	            //ֽ
	    Delay_us( 50 );
	    CS_Low;
	    Delay_us( 50 );
}   //дݺ
void LCD12864_SetXy( uint8 x, uint8 y ){
	uint8 pos;
	switch( x )
	{
		case 0:x = 0x80;
		break;
		case 1:x = 0x90;
		break;
		case 2:x = 0x88;
		break;
		case 3:x = 0x98;
		break;
	}
	pos = x + y;
	LCD12864_Serial_WriteCom( pos );  //ʾַ
}         //ú
void LCD12864_Init(){
    LCD12864_IO_Init();        //IOڳʼ
    LCD12864_Serial_Init();    //ģʽʼ
}
void LCD12864_DisplayString( char s[], uint8 x_pos, uint8 y_pos )
{
    LCD12864_SetXy( y_pos, x_pos );
    Delay_us( 5 );

    while( *s != '\0' )
    {
        LCD12864_Serial_WriteData( *s );
        s++;
    }
}

void LCD12864_DisplayNumber( uint32 num, uint8 len, uint8 x_pos, uint8 y_pos ){
    uint8 wei[10];								//޷32λΪ10λһΪ10顣
    uint8 i;
    uint8 flag = 0;								//ʾֱʶΪ0ʱflag1Ȼʼʾ֣1㲻û0

    LCD12864_SetXy( y_pos, x_pos );                                             //
    Delay_us( 5 );

    for ( i = 0; i < len; i++ )	   						//ӵλλ˳δ
    {
        wei[i] = num % 10;						        //λȡ
        num = num / 10;								//λȥ
    }

    for ( i = len; i > 0; i-- )						        //Ӹλλ˳ʾ
    {
        if ( ( wei[i-1] == 0 ) && ( flag == 0 ) && ( i > 1 ) )	                //Ӹλλ˳ʾʱδֲ0ʱʾ_LCD12864_DisplayNumber2,3ʾ__2
            LCD12864_Serial_WriteData( ' ' );

        else if( wei[i-1] != 0 )						//ֲ0ʱʶ11֮0ҲʾΪû0ˡ
            flag = 1;

        if ( flag )
            LCD12864_Serial_WriteData( wei[i-1] + 0x30 );			//ʾ֡0x300ASCII룬0x30!!!	
    }

    if ( flag == 0 )								//ѭбʶδ1˵num=0ѭʾһ0ɡ
        LCD12864_Serial_WriteData( '0' );

} //ʾֺ:numʾֵlenʾݳ
void LCD12864_DisplayDecimal( uint16 num, uint8 len ){

    uint8 wei[10];							//һΪ10飬ɱʾС10λС
    uint8 i;
                                   //
    Delay_us( 5 );

    for ( i = 0; i < len; i++ )						//ӵλλ˳δ
    {
        wei[i] = num % 10;						//λȡ
        num = num / 10;							//λȥ
    }

    LCD12864_Serial_WriteData( '.' );					//С

    for ( i = len; i > 0; i-- )						//Ӹλλ˳ʾ
    {
        LCD12864_Serial_WriteData( wei[i-1] + 0x30 );		        //ʾ֡0x300ASCII룬0x30!!! {"number"} еͲü0x30
    }
}
