
#include <MSP430G2553.H>
#include "common.h"
#include "System_Basic_Clock_Set.h"


/********************ϵͳʱú***********************
˵Source:	 ѡʱԴ1DCO   2LFXTCLK(32.77kHZ)

      Frequency: ֻʱԴѡDCOʱЧ
                 1:1MHZ   8:8MHZ   1212MHZ   1616MHZ

      Divide:	 Ƶ1:1Ƶ   2:2Ƶ   44Ƶ    8:8Ƶ  

ע⣺ϵͳʱΪLFXTCLKʱе⣬
	  رעüĴҪá롱ȻӰá
*************************************************************/

void MCLK_Set( unsigned char Source, unsigned char Frequency,unsigned char Divide )

{
    switch( Source )                            //ѡʱԴ
    {
        case 1:
          {
              BCSCTL2 |= SELM_0;                //ϵͳʱԴΪDCO 
              
              switch( Frequency )               //ΪDCOѡƵ
              {
                  case 1:
                    BCSCTL1 = CALBC1_1MHZ;      //DCOΪ1MHZ
                    DCOCTL  = CALDCO_1MHZ;
                    break;
                    
                  case 8:  
                    BCSCTL1 = CALBC1_8MHZ;      //DCOΪ8MHZ
                    DCOCTL  = CALDCO_8MHZ;
                    break;
                    
                  case 12:
                    BCSCTL1 = CALBC1_12MHZ;     //DCOΪ12MHZ
                    DCOCTL  = CALDCO_12MHZ;
                    break;
                    
                  case 16:
                    BCSCTL1 = CALBC1_16MHZ;     //DCOΪ16MHZ
                    DCOCTL  = CALDCO_16MHZ;
                    break;
                    
                  default:
                    break;
              }
              break;
          }
          
        case 2:
            BCSCTL2 |= SELM_3;                 //ϵͳʱԴΪLFXTCLK 
            ACLK_Set();                        //ⲿĴ
            break;
            
        default:
          break;
    }
    
        
    switch( Divide )                         //ѡƵ
    {
        case 1:
          BCSCTL2 |= DIVM_0;                 //1Ƶ    
          break;
          
        case 2:
          BCSCTL2 |= DIVM_1;                 //2Ƶ
          break;
          
        case 4:
          BCSCTL2 |= DIVM_2;                 //4Ƶ
          break;
          
        case 8:
          BCSCTL2 |= DIVM_3;                 //8Ƶ
          break;
    }
    
    /***ȻϵͳʱӲֱǿԽΪADC10ʱӣͨADC10CLK***/
    //ADC10CTL0 = ADC10ON;                     //ʹADC10
    //ADC10CTL1 = ADC10SSEL_2;                 //ADC10ʱѡΪMCLK
    //P1DIR |= BIT3;
    //P1SEL |= BIT3;                           //P1.3ŵĵڶACK10CLK
}




/********************ϵͳʱú***********************
˵Source:	 ѡʱԴ1DCO   2LFXTCLK(32.77kHZ)

      Frequency: ֻʱԴѡDCOʱЧ
                 1:1MHZ   8:8MHZ   1212MHZ   1616MHZ

      Divide:	 Ƶ1:1Ƶ   2:2Ƶ   44Ƶ    8:8Ƶ  

 ע⣺رעüĴҪá롱ȻӰá
*************************************************************/

void SMCLK_Set( unsigned char Source, unsigned char Frequency, unsigned char Divide )
{
    switch( Source )                            //ѡʱԴ
    {
        case 1:
          {
              BCSCTL2 &= ~SELS;                 //ϵͳʱԴΪDCO 
              switch( Frequency )               //ΪDCOѡƵ
              {
                  case 1:
                    BCSCTL1 = CALBC1_1MHZ;      //DCOΪ1MHZ
                    DCOCTL  = CALDCO_1MHZ;
                    break;
                    
                  case 8:  
                    BCSCTL1 = CALBC1_8MHZ;      //DCOΪ8MHZ
                    DCOCTL  = CALDCO_8MHZ;
                    break;
                    
                  case 12:
                    BCSCTL1 = CALBC1_12MHZ;     //DCOΪ12MHZ
                    DCOCTL  = CALDCO_12MHZ;
                    break;
                    
                  case 16:
                    BCSCTL1 = CALBC1_16MHZ;     //DCOΪ16MHZ
                    DCOCTL  = CALDCO_16MHZ;
                    break;
                    
                  default:
                    break;
              }  
          }
            break;
          
        case 2:
          {
              BCSCTL2 |= SELS;                 //ϵͳʱԴΪLFXTCLK 
              ACLK_Set();                      //ⲿĴ				 
          }
           break;
            
        default:
          break;
    }
    
    switch( Divide )                         //ѡƵ
    {
        case 1:
          BCSCTL2 |= DIVS_0;                 //1Ƶ    
          break;
          
        case 2:
          BCSCTL2 |= DIVS_1;                 //2Ƶ
          break;
          
        case 4:
          BCSCTL2 |= DIVS_2;                 //4Ƶ
          break;
          
        case 8:
          BCSCTL2 |= DIVS_3;                 //8Ƶ
          break;
    }
    
    /**********SMCLKͨP1.4**************/
    //P1DIR |= BIT4;
    //P1SEL |= BIT4;                        
}


/********ⲿLFXTCLK(32.77K)ĴúͬʱҲACLKú********/

void ACLK_Set()                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     
{
    BCSCTL1 |= XT2OFF + DIVA_0;
    BCSCTL3 |= XT2S_0 + LFXT1S_0 + XCAP_3;	//ʹGraceü
    
    /***************ACLKͨP1.0******************/
    //P1DIR |= BIT0;
    //P1SEL |= BIT0;
}


/******************ϵͳʱãMCLK,SMCLK,ACLK******************/

void System_Clock_Set()
{
    MCLK_Set ( 1, 16, 1 );
    SMCLK_Set( 1, 16, 1 );
    ACLK_Set();
}
