#include <MSP430G2553.H>
#include "common.h"
#include "GPIO.h"
#include "TLV2542.h"
#include "LCD12864.h"
static uint16 Volt;
static uint16 Unit_Digit;
static uint16 Decimals;
/*******************ADC_TLV2542˿ڳʼ*********************/
void ADC_IO_Init()//TLV2542ųʼ
{
//    GPIO_Quick_Init(1,1,3);
//    GPIO_Quick_Init(1,1,5);
//    GPIO_Quick_Init(1,0,4);
	P1DIR |=BIT3+BIT5;
	P1DIR &=~BIT4;
}


/******************TLV2542ѹɼ*****************
ע⣺1.ʱʱĴСȷ******************
**************************************/
uint16 ADC_Volt_Acquisition( uint8 Channel )//ڲ   Channel
{
    uint8 count = 0;
    uint8 channel = 0;          //ͨѡ
    uint8 High_Byte,Low_Byte;   //ݵĸ߰λͰλ
    double Temp1,Temp2;         //м
    uint16 Volt;                //ʵʵѹֵ
    float Gain_Error;           //У׼ADC

    if( Channel == 0 )          //ͨAIN1
    {
        channel = 12;
    }

    else if( Channel == 1 )     //ͨAIN0
    {
        channel = 2;            //ʱȷ
    }

    Delay_us(5000);             //ʱ
    ADC_CS_DOWN;                //Ƭѡ
    Delay_us(5000);             //ʱ
    ADC_CLK_DOWN;               //ʼʱ
    Delay_us(5000);             //ʱ

    for( count = 0; count < channel; count++ )  //Ƭѡ򿪺ʱ4-7ʱڱʼͨAIN0
    {                                           //ʱ7ʱлͨAIN1
        ADC_CLK_UP;
        Delay_us(5000);         //ʱ
        ADC_CLK_DOWN;
        Delay_us(5000);         //ʱ
    }

    ADC_CS_UP;                  //رƬѡ
    Delay_us(5000);             //ʱ

    ADC_CLK_UP;                 //ƬѡߺҪһʱص䣡мǣ
    Delay_us(5000);             //ʱ
    ADC_CLK_DOWN;
    Delay_us(5000);             //ʱ

   /* ADC_CS_DOWN;                //ٴδƬѡ
    Delay_us(5000);             //ʱ

    for( count = 0; count < 16; count++ )
    {
        ADC_CLK_UP;
        ADC_CLK_DOWN;
    }

    Delay_us( 5000 );

    ADC_CS_UP;                  //رƬѡ
    Delay_us(5000);             //ʱ

    ADC_CLK_UP;                 //ƬѡߺҪһʱص䣡мǣ
    Delay_us(5000);             //ʱ
    ADC_CLK_DOWN;
    Delay_us(5000);             //ʱ*/

    ADC_CS_DOWN;
    Delay_us(5000);             //ʱ

    High_Byte = 0;              //߰λʼ

    for( count = 0x80; count != 0; count >>= 1 )       //ȡ߰λ
    {
        ADC_CLK_UP;
        Delay_us(5000);
        ADC_CLK_DOWN;
        Delay_us(5000);

        if( ADC_DATA )
        {
            High_Byte |= count;
        }
    }

    Low_Byte = 0;               //Ͱλʼ

    for( count = 0x80; count != 0; count >>= 1 )     //ȡͰλ
    {
        ADC_CLK_UP;
        Delay_us(5000);
        ADC_CLK_DOWN;
        Delay_us(5000);

        if( ADC_DATA )
        {
            Low_Byte |= count;
        }
    }

    Delay_us( 60000 );          //16ݲɼƬѡرǰҪ3.5usʱתһҪ㹻ʱת

    ADC_CS_UP;                  //Ƭѡر
    Delay_us(5000);             //ʱ
    ADC_CLK_UP;                 //ƬѡߺҪһʱص䣡мǣ
    Delay_us(5000);             //ʱ
    ADC_CLK_DOWN;
    Delay_us(5000);             //ʱ
   Temp1 = ( High_Byte * 16 + Low_Byte / 16 );          //ȡ߰λ͵Ͱλĸλ
   Temp2 = ( ( ( Temp1 * 4096.0 ) / 4095 ) );           //óѹֵԻ׼ѹΪ4.096V,ֵУ׼
   //ｲʵʵѹֵ1000
   //
    if( Temp2 <= 900.0 )                                 //㶨귨У׼Gain_Error
    {
    	//С0.9V
        Gain_Error = 0.055;                              //ֶν㶨귨
    }

    if( ( Temp2 <= 2000.0 ) && ( Temp2 > 1000.0 ) )      //Gain_Error ԸźԴص
    {
    	//1V<Temp2<2V
        Gain_Error = 0.026;
    }

    if( ( Temp2 <= 3000.0 ) && ( Temp2 > 2000.0 ) )
    {
    	//2V<Temp2<3V
        Gain_Error = 0.0185;
    }

    if( ( Temp2 <= 4000.0 ) && ( Temp2 > 3000.0 ) )
    {
    	//3V<Temp2<4V
        Gain_Error = 0.0163;
    }

    Volt = ( uint16 )( Temp2 * ( 1.0 + Gain_Error ) );  //õ׼ȷĵѹֵ
    return ( Volt );                                    //صѹֵ
}


/**********************ѹʾ************************/
void Volt_Display()
{
    LCD12864_DisplayString( "Volt_Measure", 0, 1 );      //
    LCD12864_DisplayString( "Volt = ", 0, 2 );      //
    Volt = ADC_Volt_Acquisition( 0 );                    //ɼѹ
    Unit_Digit = Volt / 1000;//ʾֵ
    Decimals = Volt % 1000;//ʾСֵ
    LCD12864_DisplayNumber( Unit_Digit, 1, 4, 2 );
    LCD12864_DisplayDecimal( Decimals, 3 );
}
